#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# ajout_groupe.py [groupe] <partage> <lettre> <-s>
#
# Utilitaire d'ajout de groupes dans un annuaire LDAP
#
###########################################################################

#####################
# modules importés
#####################
import sys
from horus import backend

####################
# boucle principale
####################
def main():

    partage = ""
    drive = None
    sticky = False
    
    help = "ajout_groupe.py [groupe] <nom de partage> <lettre de lecteur:> <-s>"
    
    if '-s' in sys.argv:
        sticky = True
        sys.argv.remove('-s')

    try:
        # on récupère le nom du groupe
        groupe = sys.argv[1]
    except:
        sys.exit("\n pas de nom de groupe spécifié\n usage : "+help+"\n")
        
    try:
        # on récupère éventuellement le nom du partage
        partage = sys.argv[2]
    except:
        # pas de partage à créer
        pass
    else:
        # on veut en créer un, on regarde si une lettre de lecteur est spécifiée
        try:
            drive = sys.argv[3]
        except:
            # pas de lettre spécifiée
            pass
    
    # création du groupe
    retour = backend.add_group(groupe)

    if not retour :
        sys.exit("\nerreur lors de la création du groupe (déja existant ou problème LDAP) !\n")
    else:
        print("\nle groupe "+groupe+" a été ajouté avec succès dans l'annuaire")
        if partage != "":
            result = backend.add_share(partage, groupe, None, drive, sticky, sync=False)
            if not result:
                print ("\nerreur lors de la création du partage (déja existant ?)  !\n")                


# si on a appelé le programme directement : on éxecute main
if __name__ == "__main__":
    main()
