#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# inscription.py <utilisateur> <groupe1,gr2,...,grn>
#
# Utilitaire d'ajout d'utilisateur |  des groupes dans un annuaire LDAP
#
###########################################################################

###################
# modules importés
import sys
from horus import backend

###########################
# définition des fonctions
###########################

#########################################################
# fonction saisie_inter :
# ajout interactif d'un utilisateur a un (des) groupe(s)

def saisie_inter():
    print ("\n pas de fichier spécifié, passage en mode interactif \n");

    # Saisie des informations
    # login, liste de groupes

    # login
    login = raw_input(" Veuillez saisir le login de l'utilisateur : ")

    # groupe
    groupe = raw_input(" Entrez un groupe auquel ajouter l'utilisateur : ")
    temp_grp = ""

    # groupes supplémentaires, on crée une liste temporaire des groupes souhaités
    while (groupe != ""):
        temp_grp += groupe
        groupe = ""
        groupe = raw_input (" Groupe supplémentaire (<entrée> pour terminer la liste) : ")
        if groupe != "":
            temp_grp+=","
    
    # Vérification de la liste des groupes et création de la liste finale

    liste_grp=temp_grp.split(',')
    temp_grp = ""
    
    for groupe in liste_grp:

        # Recherche du groupe sur le serveur ldap

        groupe_ok = 0
        temp_grp = ""
        
        while (groupe_ok == 0):
            
            if (not backend.is_group(groupe)):
                groupe = raw_input (" le groupe "+groupe+" n'existe pas.\n Entrez un autre nom de groupe ( rien pour ne pas le remplacer) : ")
                if groupe == "":
                    groupe_ok = 1

            else:
                # le groupe a été trouvé dans la base, on lui ajoute l'utilisateur
                retour = backend.inscription(login, groupe)
                if not retour:
                    rep=""
                    while ((rep != "O") and (rep != "N")):
                        rep=raw_input("\n\nerreur lors de l'ajout de "+login+" au groupe "+groupe+", continuer ? (O/N) :")
                    if (rep == 'N'):
                        sys.exit("\nabandon, les groupes ajoutés auparavant seront pris en compte.\n\n")
                groupe_ok = 1


def saisie_non_inter(login,liste_grp):
    for groupe in liste_grp:
        
        # Recherche du groupe sur le serveur ldap
        if (not backend.is_group(groupe)):
            print("\ngroupe "+groupe+" non trouvé")
        else:
            # le groupe a été trouvé dans la base, on lui ajoute l'utilisateur
            retour = backend.inscription(login, groupe)
            if not retour:
                print("erreur lors de l'ajout de "+login+" au groupe "+groupe)


####################
# boucle principale
def main():

    #help = "inscription.py <utilisateur> <groupe1,gr2,...,grn>\n";
    
    # récupération des arguments de la ligne de commande
    try:
        utilisateur = sys.argv[1]
        groupes = sys.argv[2]
    except:
        # si pas de fichier, on passe par la saisie interactive
        saisie_inter()
    else:
        # on vérifie que le fichier est présent et lisible
        saisie_non_inter(utilisateur,groupes.split(','))


# si on a appelé le programme directement : on éxecute main
if __name__ == "__main__":
    main()
