#!/usr/bin/env python
# -*- coding: UTF-8 -*-

###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# suppression_groupe.py groupe
#
# Utilitaire de suppression d'un groupe dans l'annuaire d'Horus
#
###########################################################################

#####################
# import des modules
#####################
import sys
from horus import backend

##################
# fonctions LDAP
##################

def del_group(groupe,ignore_shares = 0):

    if not backend.is_group(groupe):
        return "erreur, le groupe n'existe pas"
        
    members = backend.get_members(groupe)
    if members != []:
        return "Erreur, ce groupe contient encore des utilisateurs"
        
    shares = backend.get_group_shares(groupe)
    if shares != []:
        if ignore_shares == 0:
            return "Erreur, le groupe "+groupe+" est lié au(x) partage(s) "+str(shares)
        
        for share in shares:
             backend.del_share(share)

    backend.del_group(groupe)
    return "groupe "+groupe+" supprimé"

            
#####################
# programme principal
#####################

def main():
    ignore_shares=0
    try:
        # on affiche le message d'aide si besoin
        if sys.argv[1] in ["--help","-h"]:
            print ("\n syntaxe : "+sys.argv[0]+" groupe1,groupe2,...,groupeN \n         ou "+sys.argv[0]+" pour le mode interactif \n")
            return
        # on regarde si un groupe est passé en ligne de commande
        groupes = sys.argv[1].split(',')
    except:
        # demande du groupe à supprimer
        groupes = []
        groupe = ""
        fin_liste = 0
        while fin_liste == 0:
            groupe = raw_input("entrez un nom de groupe (rien pour terminer la liste) : ")
            if groupe != "":
                groupes.append(groupe)
            else:
                fin_liste = 1
                
        rep = "bidon"
        while (rep.upper() != 'O') and (rep.upper() != 'N'):
            rep = 'N'
            rep = raw_input("voulez vous supprimer de l'annuaire les partages associés au groupe ? (N) : ")
            
        if rep.upper() == 'O':
            ignore_shares = 1

    # supression des groupes demandés
    for groupe in groupes:
        if ignore_shares == 1:
            print del_group(groupe,ignore_shares=1)
        else:
            print del_group(groupe)


if __name__ == '__main__':
    main()
